#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <util/delay.h>
#include <avr/wdt.h>
#include <stdio.h>

#define _s_A  2
#define _s_B  0
#define _s_C  6
#define _s_D  4
#define _s_E  3
#define _s_F  1
#define _s_G  7
#define _s_dot 5

const unsigned char segs[] =
{
	_BV(_s_A) | _BV(_s_B) | _BV(_s_C) | _BV(_s_D) | _BV(_s_E) | _BV(_s_F),	//0
	_BV(_s_B) | _BV(_s_C),	//1
	_BV(_s_A) | _BV(_s_B) | _BV(_s_D) | _BV(_s_E) | _BV(_s_G),	//2
	_BV(_s_A) | _BV(_s_B) | _BV(_s_C) | _BV(_s_D) | _BV(_s_G),  //3
	_BV(_s_B) | _BV(_s_C) | _BV(_s_F) | _BV(_s_G),	//4
	_BV(_s_A) | _BV(_s_C) | _BV(_s_D) | _BV(_s_F) | _BV(_s_G), //5
	_BV(_s_A) | _BV(_s_C) | _BV(_s_D) | _BV(_s_E) | _BV(_s_F) | _BV(_s_G), //6
	_BV(_s_A) | _BV(_s_B) | _BV(_s_C), //7
	_BV(_s_A) | _BV(_s_B) | _BV(_s_C) | _BV(_s_D) | _BV(_s_E) | _BV(_s_F) | _BV(_s_G),//8
	_BV(_s_A) | _BV(_s_B) | _BV(_s_C) | _BV(_s_F) | _BV(_s_G),//9
	
};

#define _ms(n) (17*n)

void wait(unsigned int a)	//
{							
	volatile unsigned int b,c;
	for(b=0;b!= a; b++)for(c=0;c!= 50;c++);
	return;
}

unsigned char sec=0;
unsigned char min_1=0;
unsigned char min_10=0;
unsigned char hour_1=0;
unsigned char hour_10=0;
unsigned char show_t=0;
unsigned char bell=0;

unsigned char min_1_bell=0;
unsigned char hour_1_bell=0;
unsigned char min_10_bell=0;
unsigned char hour_10_bell=0;


#define B1() (bit_is_clear(PINB,3))
#define B2() (bit_is_clear(PINB,4))
#define B3() (bit_is_clear(PINB,2))
#define B3_set PINB&0b00000100
#define bell_e	PORTC|=(1<<PC0)
#define bell_n_e	PORTC&=~(1<<PC0)



ISR(TIMER2_OVF_vect)
{
    
	if(++sec == 60){min_1++;sec=0;};
	if(min_1>9){min_1=0;min_10++;};
	if(min_10>5){min_10=0;hour_1++;};
	if(hour_1>9){hour_1=0;hour_10++;};
	if(hour_10>1 && hour_1>3){hour_1=0;hour_10=0;};

    if(min_1_bell>9){min_1_bell=0;min_10_bell++;};
	if(min_10_bell>5){min_10_bell=0;hour_1_bell++;};
	if(hour_1_bell>9){hour_1_bell=0;hour_10_bell++;};
	if(hour_10_bell>1 && hour_1_bell>3){hour_1_bell=0;hour_10_bell=0;};

 
 	if(++show_t==4) show_t=0;
	switch(show_t)//     show_t
	{
		case 0:	//show minutes
			PORTA = 0x04;
            if(bell)
				PORTD = (~segs[min_1_bell]);
			else
			PORTD = (~segs[min_1]);
			break;
		case 1:	//show 10 minutes
			PORTA = 0x08;
            if(bell)
				PORTD = (~segs[min_10_bell]);
			else
			PORTD = (~segs[min_10]);
			break;
		case 2:	//show hours
			PORTA = 0x10;
			if(bell)
			PORTD = (~segs[hour_1_bell]) & ~_BV(_s_dot);
			else
			PORTD = (~segs[hour_1]) & ~_BV(_s_dot);
			break;
		case 3:	//show 10hours
			PORTA = 0x20;
            if(bell)
			PORTD = (~segs[hour_10_bell]);
			else
			PORTD = (~segs[hour_10]);
			break;
		default:
			show_t = 0;
			break;
	}
  		return; 
}


//#define B1() (bit_is_clear(PINB,3))
//#define B2() (bit_is_clear(PINB,4))
#define B_WAIT 300
 int main (void)

{ 
    //    .
    //_delay_ms(500);

  
    
    DDRD = 0xFF;
	DDRA = 0xFF;//   A

	DDRB = 0x00;//   B 
   PORTB = 0xFF;

/* - 0*/
//TCCR0=0x06;//   0
//TCNT0=0x00;//  
           /***********************************/

    //    2.
    TIMSK &= ~(_BV(TOIE2) | _BV(OCIE2));
 
    //   2    ( 
    //   ).
    ASSR |= _BV(AS2);
 
    TCNT2 = 0x00;
    TCCR2 = 0x05; //    128.
    OCR2  = 0x00;
 
    //   .
    while (ASSR & (_BV(TCN2UB) | _BV(OCR2UB) | _BV(TCR2UB)));
 
    //     2.
    TIMSK |= _BV(TOIE2);

  
          /***********************************/

    //   .
    sei();

while(1)   //
	{
		if(B1())
		{
			wait(_ms(B_WAIT));
			min_1++;
			sec=0;
		}
		if(B2())
		{
			wait(_ms(B_WAIT));
			hour_1++;
			sec=0;
		}

        if(B3())
		{
		wait(_ms(B_WAIT));
		
		bell=1;
			//hour_1++;
		do
		{
		
		if(B1())
		{
			wait(_ms(B_WAIT));
			min_1_bell++;
			sec=0;
		}
		if(B2())
		{
			wait(_ms(B_WAIT));
			hour_1_bell++;
			sec=0;
		}

		}
		while(B3_set);
		bell=0;
		wait(_ms(B_WAIT));
		
			//sec=0;
		}
if((min_1==min_1_bell)&&(min_10==min_10_bell)&&(hour_1==hour_1_bell)&&(hour_10==hour_10_bell))
bell_e;
else
bell_n_e;
	}
 
    while(2)
    {
        sleep_enable();
        sleep_cpu();
        sleep_disable();
   
 
        TCCR2=0x05;           // Write dummy value to Control register
 
         //   2.
        while (ASSR & (_BV(TCN2UB) | _BV(OCR2UB) | _BV(TCR2UB)));
    }
  
	
    return 0;
} 
